""" Some grabbag tools """

import pymbolic.primitives as p


def get_pymbolic_basename(expr):
    assert isinstance(expr, p.Expression), "Type: {}, expr: {}".format(type(expr), expr)

    if isinstance(expr, p.Variable):
        return expr.name

    if isinstance(expr, p.Subscript):
        return get_pymbolic_basename(expr.aggregate)

    raise NotImplementedError("Cannot determine basename of {}".format(expr))


def get_pymbolic_indices(expr):
    if not isinstance(expr, p.Subscript):
        return ()

    def ind(i):
        if isinstance(i, int):
            return i
        return get_pymbolic_basename(i)

    if not isinstance(expr.index, tuple):
        return (ind(expr.index),)

    return tuple(ind(i) for i in expr.index)